
<style type="text/css">
  /*.inline {
    display: inline-block;
  }*/
</style>

<%= simple_form_for_horizontal @admin_config do |f| %>
  <%= f.error_notification %>
  <%= f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present? %>

  <%= hidden_field_tag :type, 'global' %>

  <div class="row">
    <div class="col-sm-6">
      <%#= f.input :connexions %>
      <div class='config-title'><%= Admin::AdminConfig.human_attribute_name(:connexions) %></div>
      <div class="form-inputs">
        <%= f.simple_fields_for :connexions, OpenStruct.new(@admin_config.connexions) do |fconnexion| %>
          <% @admin_config.connexions.each_key do |key| %>
            <%= fconnexion.input key.intern, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                                             label: t("connexions_#{key}", scope: ['activerecord','attributes','admin/admin_config']),
                                             label_html: {class: "label-wide-horiz"} %>
          <% end %>
        <% end %>
      </div>

      <div class='config-title'><%= User.model_name.human.pluralize %></div>
      <div class="form-inputs">
        <%= f.association :default_user_role, label_html: {class: "label-wide-horiz"} %>
        <%= f.association :default_perimeter, label_html: {class: "label-wide-horiz"} %>
      </div>

      <div class='config-title'><%= Admin::AdminConfig.human_attribute_name(:options) %></div>
      <div class="form-inputs">
        <%= f.simple_fields_for :options, OpenStruct.new(@admin_config.options) do |foptions| %>
          <%= foptions.input :image_max_size, as: :float,
                              label: t("options_image_max_size", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"} %>

          <%= foptions.input :doc_max_size, as: :float,
                              label: t("options_doc_max_size", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"} %>
          <!-- file_versions_nb_max -->
          <%= foptions.input :file_versions_nb_max, as: :integer,
                              label: t("options_file_versions_nb_max", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"} %>
        <% end %>
      </div>

      <div class='config-title'><%= "Rca options (référence)" %></div>
      <div class="form-inputs">
        <%= f.simple_fields_for :options, OpenStruct.new(@admin_config.options) do |foptions| %>
          <%= foptions.input :rca_reference, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                              label: t("options_rca_reference", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"} %>
          <%= foptions.input :rca_reference_txt,
                              label: t("options_rca_reference_txt", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"},
                              required: false %>
          <%= foptions.input :rca_reference_lock, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                              label: t("options_rca_reference_lock", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"} %>
          <hr>
          <%= foptions.input :rca_permit_assoc, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                              checked: f.object.options['rca_permit_assoc'] || 'false',
                              label: t("options_rca_permit_assoc", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"} %>
        <% end %>
      </div>

      <div class='config-title'><%= "Rca options (code)" %></div>
      <div class="form-inputs">
        <%= f.simple_fields_for :options, OpenStruct.new(@admin_config.options) do |foptions| %>
          <%= foptions.input :rca_cod, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                              checked: f.object.options['rca_cod'] || 'false',
                              label: t("options_rca_cod", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"} %>
          <%= foptions.input :rca_cod_txt,
                              # input_html: {value: f.object.options[:rca_cod_txt] || 'RCA'},
                              label: t("options_rca_cod_txt", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"},
                              required: false %>
          <%= foptions.input :rca_cod_type, collection: Rcas::GenerateBarcode.new('').types_list,
                              selected: f.object.options['rca_cod_type'] || 'Code128B',
                              label: t("options_rca_cod_type", scope: ['activerecord','attributes','admin/admin_config']),
                              label_html: {class: "label-wide-horiz"} %>
        <% end %>
      </div>

      <div class='config-title'><%= "Images entreprise (jpg ou png)" %></div>
      <div class="form-inputs">
        <div class="form-group row">
          <%= f.label :customer_logo, class: 'col-sm-3 col-form-label select required' %>
          <div class='col-sm-9'>
            <% if @admin_config.customer_logo&.attached? %>
              <p>
                <b>Filename : </b><%= @admin_config.customer_logo.filename %>
                <%= link_to fa_icon_delete, admin_admin_config_delete_customer_url(id: @admin_config.id, image: 'logo'),
                            method: :delete,
                            data: { confirm: 'Are you sure?' } %>
              </p>
            <% end %>
            <%= f.file_field :customer_logo, class: 'form-control' + (f.object.errors[:customer_logo]&.size>0 ? " is-invalid" : "") %>
            <div class='invalid-feedback'><%= f.object.errors[:customer_logo]&.to_sentence %></div>
          </div>
        </div>

        <div class="form-group row">
          <%= f.label :customer_image, class: 'col-sm-3 col-form-label select required' %>
          <div class='col-sm-9'>
            <% if @admin_config.customer_image&.attached? %>
              <p>
                <b>Filename : </b><%= @admin_config.customer_image.filename %>
                <%= link_to fa_icon_delete, admin_admin_config_delete_customer_url(id: @admin_config.id, image: 'image'),
                            method: :delete,
                            data: { confirm: 'Are you sure?' } %>
              </p>
            <% end %>
            <%= f.file_field :customer_image, class: 'form-control' + (f.object.errors[:customer_image]&.size>0 ? " is-invalid" : "") %>
            <div class='invalid-feedback'><%= f.object.errors[:customer_image]&.to_sentence %></div>
          </div>
        </div>
      </div>
    </div>

    <div class="col-sm-6">
      <div class='config-title'><%= Admin::AdminConfig.human_attribute_name(:home_options) %></div>
      <div class="form-inputs">
        <%= f.simple_fields_for :home_options, OpenStruct.new(@admin_config.home_options) do |fconnexion| %>
          <%= fconnexion.input :show_desc, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                                          label: t("home_options_show_desc", scope: ['activerecord','attributes','admin/admin_config']),
                                          label_html: {class: "label-wide-horiz"},
                                          input_html: {} %>
          <%= fconnexion.input :show_methodo, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                                          label: t("home_options_show_methodo", scope: ['activerecord','attributes','admin/admin_config']),
                                          label_html: {class: "label-wide-horiz"},
                                          input_html: {} %>
          <%= fconnexion.input :show_adv_etape, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                                          label: t("home_options_show_adv_etape", scope: ['activerecord','attributes','admin/admin_config']),
                                          label_html: {class: "label-wide-horiz"},
                                          input_html: {} %>
          <%= fconnexion.input :show_adv_role, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                                          label: t("home_options_show_adv_role", scope: ['activerecord','attributes','admin/admin_config']),
                                          label_html: {class: "label-wide-horiz"},
                                          input_html: {} %>
          <%= fconnexion.input :show_adv_duration, as: :radio_buttons, collection: [['yes', 'true'], ['no', 'false']],
                                          label: t("home_options_show_adv_duration", scope: ['activerecord','attributes','admin/admin_config']),
                                          label_html: {class: "label-wide-horiz"},
                                          input_html: {} %>
          <%= fconnexion.input :target_adv_duration, as: :integer,
                                          label: t("home_options_target_adv_duration", scope: ['activerecord','attributes','admin/admin_config']),
                                          label_html: {class: "label-wide-horiz"},
                                          input_html: {} %>

          <!-- Custom fields -->
          <div class="form-group row form-group-valid">
            <label for="customfields" class="col-form-label string label-wide-horiz col-sm-6">Ordre des champs custo</label>
            <div class="col-sm-6">
              <select name="admin_admin_config[home_options][show_custom_order][]" id="customfields" multiple size="<%= @custom_field_descs_list.size %>" class="form-control optional form-control-sm">
                <%= @custom_field_descs_list.each do |cfd| %>
                  <option value="<%= cfd.id %>"><%= cfd.name %></option>
                <% end %>
              </select>
              <a href="JavaScript:void(0);" id="btn-up">&#9650;</a>
              <a href="JavaScript:void(0);" id="btn-down">&#9660;</a>
            </div>
          </div>

          <!-- Profils -->
          <div class="form-group row form-group-valid">
            <label for="profils" class="col-form-label string label-wide-horiz col-sm-6">Profils</label>
            <div class="col-sm-6">
              <div class="admin-col">
                <div class="admin-col-title admin-col-title-grey">Profils in RCA list</div>
                <div id='labels_used' class="admin-col-content">
                  <% @profils_list.each do |profil| %>
                    <div id='<%= profil.id %>'> <!-- class='label_change_used label_used'> -->
                      <span class='label_icon label_change_used label_used'><%= fa_icon('minus-square') %></span>
                      <%= hidden_field_tag "admin_admin_config[home_options][show_profil][]", profil.id %>
                      <%= profil.name %>
                    </div>
                  <% end %>
                </div>
              </div>
              <div class="admin-col">
                <div class="admin-col-title admin-col-title-grey">Profils (all)</div>
                <div id='labels_unused' class="admin-col-content">
                  <% @profils_list_all.each do |profil| %>
                    <div id='<%= profil.id %>'>
                      <span class='label_icon label_change_used label_unused'><%= fa_icon('plus-square') %></span>
                      <%= profil.name %>
                    </div>
                  <% end %>
                </div>
              </div>
            </div>
          </div>
        <% end %>
      </div>
    </div>
  </div>

  <br>

  <div class="form-actions">
    <%= f.button :submit, id: 'submit_button', class: 'btn btn-outline-warning' %>
  </div>
<% end %>

<script text="javascript">
  $(function() {
    $('.label-wide-horiz').each(function() {
      $(this).removeClass('col-sm-3').addClass('col-sm-6');
      $(this).next().removeClass('col-sm-9').addClass('col-sm-6');
    });

    $('input[name="admin_admin_config[task_mails][activate]"][type=radio][checked=checked]').each(function() {
      console.log(this);
      console.log($(this).val());
      if ($(this).val() == 'false') {
        $('#task-mails-options').hide();
      }
    });

    $('input[name="admin_admin_config[task_mails][activate]"][type=radio]').click(function() {
      console.log(this);
      console.log($(this).val());
      if ($(this).val() == 'false') {
        $('#task-mails-options').hide();
      }
      else {
        $('#task-mails-options').show();
      }
    });

    // LISTE DES CUSTOM FIELDS
    $('#btn-up').bind('click', function() {
        $('#customfields option:selected').each( function() {
            var newPos = $('#customfields option').index(this) - 1;
            if (newPos > -1) {
                $('#customfields option').eq(newPos).before("<option value='"+$(this).val()+"' selected='selected'>"+$(this).text()+"</option>");
                $(this).remove();
            }
        });
    });
    $('#btn-down').bind('click', function() {
        var countOptions = $('#customfields option').size();
        $('#customfields option:selected').each( function() {
            var newPos = $('#customfields option').index(this) + 1;
            if (newPos < countOptions) {
                $('#customfields option').eq(newPos).after("<option value='"+$(this).val()+"' selected='selected'>"+$(this).text()+"</option>");
                $(this).remove();
            }
        });
    });

    // Select all options to send all list content (ordered) to controller update
    $("#submit_button").on('click', function(event) {
      console.log('SUBMITED !!!');
      $('#customfields option').prop('selected', true);
    })


    // PROFILS
    $(".label_change_used").click(function(event) {
      console.log("Del label");
      console.log(this.value);

      if($(this).hasClass('label_unused')) {
        console.log("Add label");
        $(this).removeClass('label_unused').addClass('label_used');
        $(this).parent().detach().appendTo('#labels_used');
        $(this).parent().append($('<input>')
              .attr({ type: 'hidden',
                      id: 'admin_admin_config_home_options_show_profil_',
                      name: 'admin_admin_config[home_options][show_profil][]',
                      value: $(this).parent().attr('id')
                    }));
        $(this).html('<%= fa_icon("minus-square") %>');
      }
      else {
        console.log("Del label");
        $(this).removeClass('label_used').addClass('label_unused');
        $(this).parent().detach().appendTo('#labels_unused');
        $(this).parent().children( "#admin_admin_config_home_options_show_profil_").remove()
        $(this).html('<%= fa_icon("plus-square") %>');
      }
    });

    // $("#labels_used").sortable();
  });
</script>
